/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.kintai.common.action;

import jp.mosp.common.CommonConst;
import jp.mosp.common.dao.MCodeDao;
import jp.mosp.common.dto.MCodeDto;
import jp.mosp.common.utils.TimeUtil;

/**
 * @author yoshida
 *
 */
public abstract class MosPCodeAction extends KintaiCommonAction {
	
	/**
	 * キーによる情報の取得
	 * @param tid		コード名
	 * @param tcode		コード
	 * @return	検索結果(DTO)
	 * @throws Exception	例外処理が発生した場合
	 */
	protected MCodeDto findForKey(String tid, String tcode) throws Exception {
		return part().mospcode().findForKey(tid, tcode);
	}
	
	/**
	 * キーによる情報の取得
	 * @param tid		コード名
	 * @param tcode		コード
	 * @return 対象コード名、対象コードのコード変換文字列
	 * @throws Exception 	例外処理が発生した場合
	 */
	protected String findTchange(String tid, String tcode) throws Exception {
		return part().mospcode().findTchange(tid, tcode);
	}
	
	/**
	 * 更新処理
	 * @param tId		コード名
	 * @param tCode		コード
	 * @param tName		コード名称
	 * @param tChange	コード変換
	 * @throws Exception	 例外処理が発生した場合
	 */
	protected void regist(String tId, String tCode, String tName, String tChange) throws Exception {
		// DAOの準備
		MCodeDao dao = part().mospcode().getMCodeDao();
		// DTOの取得
		MCodeDto dto = dao.findForUpdate(tId, tCode);
		if (chkExistDto(dto)) {
			// DTOの準備
			dto.setTName(tName);
			dto.setTChange(tChange);
			// 排他確認
			chkExclusive(dao.findForKey(dto.getTId(), dto.getTCode()), dto);
			// データの更新		
			dao.update(dto);
		} else {
			// DTOの準備
			dto = new MCodeDto();
			dto.setTId(tId);
			dto.setTCode(tCode);
			dto.setTName(tName);
			dto.setTChange(tChange);
			// データの登録		
			dao.insert(dto);
		}
		// アップデートのチェック
		chkUpdate(dao.findForKey(dto.getTId(), dto.getTCode()));
	}
	
	/**
	 * m_code用時刻コード生成メソッド
	 * @param h1	時
	 * @param m1	分
	 * @param h2	時
	 * @param m2	分
	 * @return	string	結合文字列
	 */
	protected String convStringToTimeCode(String h1, String m1, String h2, String m2) {
		StringBuffer sb = new StringBuffer();
		sb.append(TimeUtil.convStringTimeFormatted(h1, m1));
		sb.append(CommonConst.STR_SLASH_SEPARATOR);
		sb.append(TimeUtil.convStringTimeFormatted(h2, m2));
		sb.append(CommonConst.STR_SLASH_SEPARATOR);
		return sb.toString();
	}
	
}
